package com.gps.model;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.StringReader;
import java.io.StringWriter;
import java.net.Socket;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import android.content.Context;
import android.util.Log;

public class WsFunctions {
	
	public WsFunctions() {
		super();
	}

	public String callWebService(String enveloppe)
	{  
	    String serveur = "orws2.isima.fr";// ="orws.isima.fr";
	    //String serveur = "10.0.2.2";// ="orws.isima.fr";
	    int port= 80;//8080; 
	    String resulat_soap="";
	    
	    try {
            	  //------------------------------------------------------------
	        	  // socket
	        	  //------------------------------------------------------------        		  
	        	  Socket S = null;
	        	  S= new Socket(serveur,port);
	        	  InputStream input = S.getInputStream();
	              OutputStream output2 = S.getOutputStream();
	              
	              BufferedReader Buffer = new BufferedReader(new InputStreamReader(input));
	              PrintWriter BufferSortie = new PrintWriter(new OutputStreamWriter(output2));
	     
//	              BufferSortie.println("POST http://10.0.2.2:8080/GpsWebService/GpsWebService HTTP/1.1");
	              BufferSortie.println("POST /GpsWebService/GpsWebService HTTP/1.1");
	              BufferSortie.println("Host: "+ serveur+":"+port);
	              BufferSortie.println("Content-type: text/xml;charset=\"utf-8\"");
	              BufferSortie.println("SOAPAction = \"http://webService.com.gps/GpsWebService/GpsWebService\"");
	              BufferSortie.println("Accept: text/xml, multipart/related, text/html, image/gif, image/jpeg, *; q=.2, */*; q=.2");
	              BufferSortie.println("User-Agent: JAX-WS RI 2.1.6 in JDK 6");
	              BufferSortie.println("Connection: keep-alive");
	              BufferSortie.println("Content-Length: "+enveloppe.length());
	              BufferSortie.println("");
	              BufferSortie.println(enveloppe);
	              BufferSortie.println("");
	              BufferSortie.flush();
             
	             try{
	            	 
	             	//partie x1: enlever l'entete HTTP
	            	String ligne = Buffer.readLine();
	            	if(!ligne.contains("HTTP/1.1 200 OK"))
	            	{	         
	            		System.out.println("HTTP/1.1 200 OK");
	            		//return null;
	            	}
    	            do{  
    	            	ligne = Buffer.readLine();	
    	            	if(ligne.length()==0)
    	            		break;
    	            	
    	            }while(true);  
	            	 
    	            boolean nouveau_packet=true;
    	            int taille_packet =0;
    	            int taille_lu=0;
    	            int compteur=0;
    	            
    	            //partie x2: recuperer les donnees
    	            do{
	                   
	                    ligne = Buffer.readLine();
	                    if(ligne.length()==0)
	                    	break;
	                    
	                    if(nouveau_packet)
	                    {
	                    	nouveau_packet=false;
	                    	taille_packet = Integer.parseInt(ligne,16);
	                    	taille_lu=0;
	                    	//la taille de cette ligne ne compte pas
	                    	if(taille_packet==0)break;
	                    }
	                    else
	                    {
	                    	resulat_soap=resulat_soap+ligne;  
	                    	//-> compteurencodage utf-8
	                    	taille_lu+=ligne.getBytes("UTF-8").length+1; // +1  -> le retour de la ligne
	                    }
	                    
	                    if(taille_lu >= taille_packet)  
	                    	nouveau_packet = true; 
	                    
	               }while(true && compteur<1000);
	                  
	              }catch(Exception e)
	              {
	                   System.out.println(e.getMessage());
	                   final String bug= e.getMessage();
	                   return null;
	              }  
	               
	            BufferSortie.close();
	            output2.close();
	            input.close();
	            S.close();
	          
        	  }
	    	  catch ( Exception e) 
	    	  {
	    		   System.out.println(e.getMessage());
	    		   final String bug= e.getMessage();
	    		   return null;
	    	 }
	    
	    return resulat_soap;		
	}
	
	public String callFunction(String functionName, Map<String,String> map) {
		
		String result = "<?xml version=\"1.0\"?>" +
						"<S:Envelope xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">" +
						"<S:Body><ns2:" + functionName +" xmlns:ns2=\"http://webService.com.gps/\">";
		
		if(map != null) {
			for(String mapKey : map.keySet()) {
				result += "<" + mapKey +">"+ map.get(mapKey) +"</" + mapKey +">";				
			}
			
			result += "</ns2:"+ functionName +"></S:Body></S:Envelope>";
		} else {
			result = null;
		}
	
		return result;
	}
	
	public String callFunctionWP(String functionName) {
		
		String result = "<?xml version=\"1.0\"?>" +
						"<S:Envelope xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">" +
						"<S:Body><ns2:" + functionName +" xmlns:ns2=\"http://webService.com.gps/\">";
		
					
		result += "</ns2:"+ functionName +"></S:Body></S:Envelope>";		
	
		return result;
	}

	
	
	
	
	/* ************************************
	 * 			Functions utility
	 *************************************/
	/**
	 * 
	 * @param response
	 * @param parameter : Listes des paramtres que nous souhaitons retourner
	 * @return
	 * @throws JSONException 
	 */
	public JSONObject parseSoapResponse(String response, List<String> parameter, String parsingValue) throws JSONException {
	
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();  
	    DocumentBuilder builder;  
	    JSONObject responseDetailsJson = new JSONObject();
        JSONArray jsonArray = new JSONArray();
	    try  {  	    	
	        builder = factory.newDocumentBuilder();  
	        Document document = builder.parse( new InputSource( new StringReader(response) ) );  
	        document.getDocumentElement().normalize();
	        //retourne les returns dans le XML.
	        NodeList nodeList = document.getElementsByTagName(parsingValue);
	        for(int i=0; i<nodeList.getLength() ; i++){
	        	Node nNode = nodeList.item(i);
	        	JSONObject json = new JSONObject();   	
		        
        		Element eElement = (Element) nNode;
        		
        		for(int j=0; j<parameter.size(); ++j) {	        			

        			if(eElement.getElementsByTagName(parameter.get(j)).getLength() != 0) {
            			if(eElement.getElementsByTagName(parameter.get(j)).getLength() > 1) {
            				json.put(parameter.get(j), eElement.getElementsByTagName(parameter.get(j)).item(1).getTextContent());
            			} else {
            				json.put(parameter.get(j), eElement.getElementsByTagName(parameter.get(j)).item(0).getTextContent());
            			}
        				
        			}		        				        		
        		}	     
        		jsonArray.put(json);		               	
	        }
	        
	    } catch (Exception e) {  
	        e.printStackTrace();  
	    }	    
	    
	    responseDetailsJson.put("result", jsonArray);
	    return responseDetailsJson;
	}
	
	/**
	 * Function pour parser la rponse SOAP
	 * @param result : chaine  parser
	 * @param chaine1 : Element de recherche deb, par ex : <return>
	 * @param chaine2 : Element de rechercher fin, par ex : </return>
	 * @return
	 */
	public String parse(String result, String chaine){
		String chaine1 = "<"+chaine+">";
		String chaine2 = "</"+chaine+">";
		int response = result.indexOf(chaine1);
	    int response2 = result.indexOf(chaine2);
	    	    
	    return (String) result.subSequence(response+chaine1.length(), response2);
	}
	
	/**
	 * Parser une rponse et la rendre en tant que MAP
	 * @param response
	 * @return
	 */
	public Map<String,String> parseResponse(String response) {
		
	    Map<String, String> param = new HashMap<String, String>();
		
	    while(response.length()>1) {
	    	int index = response.indexOf("</");
	    	int index2 = response.indexOf(">", index);
	    	String key = (String) response.subSequence(index+ "</".length(), index2);
	    	String value = parse(response, key);
	    	param.put(key, value.toString());
	    	response = response.substring(index2+1);
	    }
		
		return param;
	}
	
	public String generateKey(String key) {
        int min = 0;
        int max = 9;
        
        int range1 = min + (int)(Math.random() * ((max - min) + 1));
        if(range1==0) ++range1;
        max = 10-range1;
        int range2 = min + (int)(Math.random() * ((max - min) + 1)); 
        int range3 = 10 - range2 - range1;
        
        Date d = new Date();
        SimpleDateFormat f = new SimpleDateFormat("yyyyMMdd'T'HHmmss");
        String s = f.format(d);
        
        return key+s+range1+range2+range3;
	}
}
